// Textured, vary color

#ifdef GL_ES
precision mediump float;
#else
#define lowp
#define mediump
#define highp
#endif

uniform sampler2D texture, blur_texture;
varying vec2 v_texcoord;

uniform float blur;
varying vec2 dist;

#define SQRT2 0.707106781
#define VELOCITY_MAX 10.0

vec4 tryMotion(vec2 at) {
	vec2 v = ( texture2D(blur_texture, v_texcoord + at).rg - vec2(0.5,0.5) ) * VELOCITY_MAX;
	vec4 color = texture2D(texture, v_texcoord + at);
	return dot(v,at) * color;
	return color;
}

void main(void)
{
	float b = blur;
	float b2 = b*SQRT2;
	vec4 sum = 
		(// texture2D(texture, v_texcoord)
		 +tryMotion( vec2(-b2, b2) )
		 +tryMotion( vec2( b2, b2) )
		 +tryMotion( vec2(-b2,-b2) )
		 +tryMotion( vec2( b2,-b2) )
		 +tryMotion( vec2(-b, 0) )
		 +tryMotion( vec2( b, 0) )
		 +tryMotion( vec2( 0,-b) )
		 +tryMotion( vec2( 0, b) )
		   );
		   
	gl_FragColor = sum / sum.a;
}